/* bookmarks.c generated by valac 0.40.10, the Vala compiler
 * generated from bookmarks.vala, do not modify */

/*
  This file is part of Dconf Editor

  Dconf Editor is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Dconf Editor is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Dconf Editor.  If not, see <https://www.gnu.org/licenses/>.
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define TYPE_BOOKMARKS (bookmarks_get_type ())
#define BOOKMARKS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOOKMARKS, Bookmarks))
#define BOOKMARKS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOOKMARKS, BookmarksClass))
#define IS_BOOKMARKS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOOKMARKS))
#define IS_BOOKMARKS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOOKMARKS))
#define BOOKMARKS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOOKMARKS, BookmarksClass))

typedef struct _Bookmarks Bookmarks;
typedef struct _BookmarksClass BookmarksClass;
typedef struct _BookmarksPrivate BookmarksPrivate;
enum  {
	BOOKMARKS_0_PROPERTY,
	BOOKMARKS_SCHEMA_PATH_PROPERTY,
	BOOKMARKS_NUM_PROPERTIES
};
static GParamSpec* bookmarks_properties[BOOKMARKS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_VIEW_TYPE (view_type_get_type ())
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

#define TYPE_BOOKMARK (bookmark_get_type ())
#define BOOKMARK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOOKMARK, Bookmark))
#define BOOKMARK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOOKMARK, BookmarkClass))
#define IS_BOOKMARK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOOKMARK))
#define IS_BOOKMARK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOOKMARK))
#define BOOKMARK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOOKMARK, BookmarkClass))

typedef struct _Bookmark Bookmark;
typedef struct _BookmarkClass BookmarkClass;
typedef struct _Block1Data Block1Data;
typedef struct _BookmarkPrivate BookmarkPrivate;
enum  {
	BOOKMARK_0_PROPERTY,
	BOOKMARK_NUM_PROPERTIES
};
static GParamSpec* bookmark_properties[BOOKMARK_NUM_PROPERTIES];
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Bookmarks {
	GtkMenuButton parent_instance;
	BookmarksPrivate * priv;
};

struct _BookmarksClass {
	GtkMenuButtonClass parent_class;
};

struct _BookmarksPrivate {
	GtkListBox* bookmarks_list_box;
	GtkPopover* bookmarks_popover;
	GtkImage* bookmarks_icon;
	GtkSwitch* bookmarked_switch;
	gchar* current_path;
	gchar* schema_id;
	gchar* _schema_path;
	GSettings* settings;
};

typedef enum  {
	VIEW_TYPE_OBJECT,
	VIEW_TYPE_FOLDER,
	VIEW_TYPE_SEARCH
} ViewType;

struct _Block1Data {
	int _ref_count_;
	Bookmarks* self;
	gulong bookmarks_changed_handler;
	gulong clicked_handler;
};

struct _Bookmark {
	GtkListBoxRow parent_instance;
	BookmarkPrivate * priv;
};

struct _BookmarkClass {
	GtkListBoxRowClass parent_class;
};

struct _BookmarkPrivate {
	GtkLabel* bookmark_label;
	GtkButton* destroy_button;
};


static gpointer bookmarks_parent_class = NULL;
static gpointer bookmark_parent_class = NULL;

GType bookmarks_get_type (void) G_GNUC_CONST;
#define BOOKMARKS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_BOOKMARKS, BookmarksPrivate))
static void bookmarks_bookmark (Bookmarks* self,
                         GSimpleAction* action,
                         GVariant* path_variant);
static void _bookmarks_bookmark_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self);
static void bookmarks_unbookmark (Bookmarks* self,
                           GSimpleAction* action,
                           GVariant* path_variant);
static void _bookmarks_unbookmark_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self);
GType view_type_get_type (void) G_GNUC_CONST;
void bookmarks_set_path (Bookmarks* self,
                         ViewType type,
                         const gchar* path);
static void bookmarks_update_icon_and_switch (Bookmarks* self);
gchar** bookmarks_get_bookmarks (Bookmarks* self,
                                 int* result_length1);
void bookmarks_set_bookmarked (Bookmarks* self,
                               const gchar* path,
                               gboolean new_state);
static void bookmarks_append_bookmark (Bookmarks* self,
                                const gchar* path);
static void bookmarks_remove_bookmark (Bookmarks* self,
                                const gchar* bookmark_name);
static void bookmarks_install_action_entries (Bookmarks* self);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      int stack_length,
                                      gchar* needle);
static void bookmarks_update_switch (Bookmarks* self,
                              gboolean bookmarked);
static void bookmarks_update_bookmarks (Bookmarks* self);
static void __lambda4_ (Bookmarks* self,
                 GtkWidget* widget);
static void ___lambda4__gtk_callback (GtkWidget* widget,
                               gpointer self);
static void _vala_array_add1 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
GType bookmark_get_type (void) G_GNUC_CONST;
Bookmark* bookmark_new (const gchar* bookmark_name);
Bookmark* bookmark_construct (GType object_type,
                              const gchar* bookmark_name);
gboolean settings_model_is_key_path (const gchar* path);
static void _vala_array_add2 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add3 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
Bookmarks* bookmarks_new (void);
Bookmarks* bookmarks_construct (GType object_type);
static const gchar* bookmarks_get_schema_path (Bookmarks* self);
static void bookmarks_set_schema_path (Bookmarks* self,
                                const gchar* value);
static GObject * bookmarks_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void _bookmarks___lambda96_ (Bookmarks* self);
static void __bookmarks___lambda96__g_settings_changed (GSettings* _sender,
                                                 const gchar* key,
                                                 gpointer self);
static void _bookmarks___lambda97_ (Bookmarks* self);
static void __bookmarks___lambda97__gtk_button_clicked (GtkButton* _sender,
                                                 gpointer self);
static void _bookmarks___lambda98_ (Block1Data* _data1_);
static void __bookmarks___lambda98__gtk_widget_destroy (GtkWidget* _sender,
                                                 gpointer self);
static void bookmarks_finalize (GObject * obj);
static void _vala_bookmarks_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_bookmarks_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
#define BOOKMARK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_BOOKMARK, BookmarkPrivate))
static void bookmark_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static const GActionEntry BOOKMARKS_action_entries[2] = {{"bookmark", _bookmarks_bookmark_gsimple_action_activate_callback, "s"}, {"unbookmark", _bookmarks_unbookmark_gsimple_action_activate_callback, "s"}};

static void
_bookmarks_bookmark_gsimple_action_activate_callback (GSimpleAction* action,
                                                      GVariant* parameter,
                                                      gpointer self)
{
#line 98 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	bookmarks_bookmark ((Bookmarks*) self, action, parameter);
#line 229 "bookmarks.c"
}


static void
_bookmarks_unbookmark_gsimple_action_activate_callback (GSimpleAction* action,
                                                        GVariant* parameter,
                                                        gpointer self)
{
#line 98 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	bookmarks_unbookmark ((Bookmarks*) self, action, parameter);
#line 240 "bookmarks.c"
}


void
bookmarks_set_path (Bookmarks* self,
                    ViewType type,
                    const gchar* path)
{
	const gchar* _tmp0_;
#line 59 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_return_if_fail (self != NULL);
#line 59 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_return_if_fail (path != NULL);
#line 61 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	if (type == VIEW_TYPE_SEARCH) {
#line 62 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		return;
#line 258 "bookmarks.c"
	}
#line 64 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp0_ = self->priv->current_path;
#line 64 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	if (g_strcmp0 (_tmp0_, path) != 0) {
#line 264 "bookmarks.c"
		gchar* _tmp1_;
#line 65 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp1_ = g_strdup (path);
#line 65 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_g_free0 (self->priv->current_path);
#line 65 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		self->priv->current_path = _tmp1_;
#line 272 "bookmarks.c"
	}
#line 66 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	bookmarks_update_icon_and_switch (self);
#line 276 "bookmarks.c"
}


gchar**
bookmarks_get_bookmarks (Bookmarks* self,
                         int* result_length1)
{
	gchar** result = NULL;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
#line 70 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp0_ = self->priv->settings;
#line 72 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, "bookmarks");
#line 72 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp3_ = _tmp2_;
#line 72 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp3__length1 = _vala_array_length (_tmp1_);
#line 72 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	if (result_length1) {
#line 72 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		*result_length1 = _tmp3__length1;
#line 304 "bookmarks.c"
	}
#line 72 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	result = _tmp3_;
#line 72 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	return result;
#line 310 "bookmarks.c"
}


void
bookmarks_set_bookmarked (Bookmarks* self,
                          const gchar* path,
                          gboolean new_state)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 76 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_return_if_fail (self != NULL);
#line 76 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_return_if_fail (path != NULL);
#line 78 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp1_ = self->priv->current_path;
#line 78 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	if (g_strcmp0 (path, _tmp1_) == 0) {
#line 329 "bookmarks.c"
		GtkSwitch* _tmp2_;
#line 78 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp2_ = self->priv->bookmarked_switch;
#line 78 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp0_ = gtk_switch_get_active (_tmp2_) == new_state;
#line 335 "bookmarks.c"
	} else {
#line 78 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp0_ = FALSE;
#line 339 "bookmarks.c"
	}
#line 78 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	if (_tmp0_) {
#line 79 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		return;
#line 345 "bookmarks.c"
	}
#line 81 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	if (new_state) {
#line 82 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		bookmarks_append_bookmark (self, path);
#line 351 "bookmarks.c"
	} else {
#line 84 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		bookmarks_remove_bookmark (self, path);
#line 355 "bookmarks.c"
	}
}


static void
bookmarks_install_action_entries (Bookmarks* self)
{
	GSimpleActionGroup* action_group = NULL;
	GSimpleActionGroup* _tmp0_;
#line 91 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_return_if_fail (self != NULL);
#line 93 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp0_ = g_simple_action_group_new ();
#line 93 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	action_group = _tmp0_;
#line 94 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_action_map_add_action_entries ((GActionMap*) action_group, BOOKMARKS_action_entries, G_N_ELEMENTS (BOOKMARKS_action_entries), self);
#line 95 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "bookmarks", (GActionGroup*) action_group);
#line 91 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_g_object_unref0 (action_group);
#line 377 "bookmarks.c"
}


static void
bookmarks_bookmark (Bookmarks* self,
                    GSimpleAction* action,
                    GVariant* path_variant)
{
	const gchar* _tmp0_;
#line 104 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_return_if_fail (self != NULL);
#line 104 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_return_if_fail (action != NULL);
#line 104 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_vala_return_if_fail (path_variant != NULL, "path_variant != null");
#line 107 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp0_ = g_variant_get_string ((GVariant*) path_variant, NULL);
#line 107 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	bookmarks_append_bookmark (self, _tmp0_);
#line 397 "bookmarks.c"
}


static void
bookmarks_unbookmark (Bookmarks* self,
                      GSimpleAction* action,
                      GVariant* path_variant)
{
	const gchar* _tmp0_;
#line 110 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_return_if_fail (self != NULL);
#line 110 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_return_if_fail (action != NULL);
#line 110 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_vala_return_if_fail (path_variant != NULL, "path_variant != null");
#line 113 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp0_ = g_variant_get_string ((GVariant*) path_variant, NULL);
#line 113 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	bookmarks_remove_bookmark (self, _tmp0_);
#line 417 "bookmarks.c"
}


static gboolean
_vala_string_array_contains (gchar* * stack,
                             int stack_length,
                             gchar* needle)
{
	int i;
#line 123 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	for (i = 0; i < stack_length; i++) {
#line 123 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 123 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
			return TRUE;
#line 433 "bookmarks.c"
		}
	}
#line 123 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	return FALSE;
#line 438 "bookmarks.c"
}


static void
bookmarks_update_icon_and_switch (Bookmarks* self)
{
	GVariant* variant = NULL;
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	const gchar* _tmp2_;
	GSettings* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gboolean _tmp7_;
#line 120 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_return_if_fail (self != NULL);
#line 122 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp0_ = self->priv->current_path;
#line 122 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 122 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_variant_ref_sink (_tmp1_);
#line 122 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	variant = _tmp1_;
#line 123 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp2_ = self->priv->current_path;
#line 123 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp3_ = self->priv->settings;
#line 123 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp5_ = _tmp4_ = g_settings_get_strv (_tmp3_, "bookmarks");
#line 123 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp6_ = _tmp5_;
#line 123 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp6__length1 = _vala_array_length (_tmp4_);
#line 123 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp7_ = _vala_string_array_contains (_tmp6_, _vala_array_length (_tmp4_), _tmp2_);
#line 123 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
#line 123 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	if (_tmp7_) {
#line 481 "bookmarks.c"
		GtkImage* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gboolean _tmp12_;
		GtkSwitch* _tmp14_;
		GVariant* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
#line 125 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp8_ = self->priv->bookmarks_icon;
#line 125 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		g_object_get (_tmp8_, "icon-name", &_tmp9_, NULL);
#line 125 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp10_ = _tmp9_;
#line 125 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp11_ = _tmp10_;
#line 125 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp12_ = g_strcmp0 (_tmp11_, "starred-symbolic") != 0;
#line 125 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_g_free0 (_tmp11_);
#line 125 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		if (_tmp12_) {
#line 509 "bookmarks.c"
			GtkImage* _tmp13_;
#line 126 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
			_tmp13_ = self->priv->bookmarks_icon;
#line 126 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
			g_object_set (_tmp13_, "icon-name", "starred-symbolic", NULL);
#line 515 "bookmarks.c"
		}
#line 127 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		bookmarks_update_switch (self, TRUE);
#line 128 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp14_ = self->priv->bookmarked_switch;
#line 128 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp15_ = variant;
#line 128 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp16_ = g_variant_print (_tmp15_, FALSE);
#line 128 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp17_ = _tmp16_;
#line 128 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp18_ = g_strconcat ("bookmarks.unbookmark(", _tmp17_, NULL);
#line 128 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp19_ = _tmp18_;
#line 128 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp20_ = g_strconcat (_tmp19_, ")", NULL);
#line 128 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp21_ = _tmp20_;
#line 128 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp14_, _tmp21_);
#line 128 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_g_free0 (_tmp21_);
#line 128 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_g_free0 (_tmp19_);
#line 128 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_g_free0 (_tmp17_);
#line 543 "bookmarks.c"
	} else {
		GtkImage* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gboolean _tmp26_;
		GtkSwitch* _tmp28_;
		GVariant* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
#line 132 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp22_ = self->priv->bookmarks_icon;
#line 132 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		g_object_get (_tmp22_, "icon-name", &_tmp23_, NULL);
#line 132 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp24_ = _tmp23_;
#line 132 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp25_ = _tmp24_;
#line 132 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp26_ = g_strcmp0 (_tmp25_, "non-starred-symbolic") != 0;
#line 132 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_g_free0 (_tmp25_);
#line 132 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		if (_tmp26_) {
#line 572 "bookmarks.c"
			GtkImage* _tmp27_;
#line 133 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
			_tmp27_ = self->priv->bookmarks_icon;
#line 133 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
			g_object_set (_tmp27_, "icon-name", "non-starred-symbolic", NULL);
#line 578 "bookmarks.c"
		}
#line 134 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		bookmarks_update_switch (self, FALSE);
#line 135 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp28_ = self->priv->bookmarked_switch;
#line 135 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp29_ = variant;
#line 135 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp30_ = g_variant_print (_tmp29_, FALSE);
#line 135 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp31_ = _tmp30_;
#line 135 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp32_ = g_strconcat ("bookmarks.bookmark(", _tmp31_, NULL);
#line 135 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp33_ = _tmp32_;
#line 135 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp34_ = g_strconcat (_tmp33_, ")", NULL);
#line 135 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp35_ = _tmp34_;
#line 135 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp28_, _tmp35_);
#line 135 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_g_free0 (_tmp35_);
#line 135 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_g_free0 (_tmp33_);
#line 135 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_g_free0 (_tmp31_);
#line 606 "bookmarks.c"
	}
#line 120 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_g_variant_unref0 (variant);
#line 610 "bookmarks.c"
}


static void
bookmarks_update_switch (Bookmarks* self,
                         gboolean bookmarked)
{
	GtkSwitch* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GtkSwitch* _tmp3_;
	GtkSwitch* _tmp4_;
#line 138 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_return_if_fail (self != NULL);
#line 140 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp0_ = self->priv->bookmarked_switch;
#line 140 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp1_ = gtk_switch_get_active (_tmp0_);
#line 140 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp2_ = _tmp1_;
#line 140 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	if (bookmarked == _tmp2_) {
#line 141 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		return;
#line 635 "bookmarks.c"
	}
#line 142 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp3_ = self->priv->bookmarked_switch;
#line 142 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp3_, "ui.empty('')");
#line 143 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp4_ = self->priv->bookmarked_switch;
#line 143 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	gtk_switch_set_active (_tmp4_, bookmarked);
#line 645 "bookmarks.c"
}


static void
__lambda4_ (Bookmarks* self,
            GtkWidget* widget)
{
#line 148 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_return_if_fail (widget != NULL);
#line 148 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	gtk_widget_destroy (widget);
#line 657 "bookmarks.c"
}


static void
___lambda4__gtk_callback (GtkWidget* widget,
                          gpointer self)
{
#line 148 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	__lambda4_ ((Bookmarks*) self, widget);
#line 667 "bookmarks.c"
}


static void
_vala_array_add1 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 156 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	if ((*length) == (*size)) {
#line 156 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 156 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 683 "bookmarks.c"
	}
#line 156 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	(*array)[(*length)++] = value;
#line 156 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	(*array)[*length] = NULL;
#line 689 "bookmarks.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 172 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	return self ? g_object_ref (self) : NULL;
#line 698 "bookmarks.c"
}


static void
bookmarks_update_bookmarks (Bookmarks* self)
{
	GtkListBox* _tmp0_;
	gchar** bookmarks = NULL;
	GSettings* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint bookmarks_length1;
	gint _bookmarks_size_;
	gchar** unduplicated_bookmarks = NULL;
	gchar** _tmp4_;
	gint unduplicated_bookmarks_length1;
	gint _unduplicated_bookmarks_size_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	GtkListBoxRow* first_row = NULL;
	GtkListBox* _tmp38_;
	GtkListBoxRow* _tmp39_;
	GtkListBoxRow* _tmp40_;
	GtkListBoxRow* _tmp41_;
#line 146 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_return_if_fail (self != NULL);
#line 148 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp0_ = self->priv->bookmarks_list_box;
#line 148 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	gtk_container_foreach ((GtkContainer*) _tmp0_, ___lambda4__gtk_callback, self);
#line 150 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp1_ = self->priv->settings;
#line 150 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "bookmarks");
#line 150 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	bookmarks = _tmp3_;
#line 150 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	bookmarks_length1 = _vala_array_length (_tmp2_);
#line 150 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_bookmarks_size_ = bookmarks_length1;
#line 151 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp4_ = g_new0 (gchar*, 0 + 1);
#line 151 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	unduplicated_bookmarks = _tmp4_;
#line 151 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	unduplicated_bookmarks_length1 = 0;
#line 151 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_unduplicated_bookmarks_size_ = unduplicated_bookmarks_length1;
#line 152 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp5_ = bookmarks;
#line 152 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp5__length1 = bookmarks_length1;
#line 751 "bookmarks.c"
	{
		gchar** bookmark_collection = NULL;
		gint bookmark_collection_length1 = 0;
		gint _bookmark_collection_size_ = 0;
		gint bookmark_it = 0;
#line 152 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		bookmark_collection = _tmp5_;
#line 152 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		bookmark_collection_length1 = _tmp5__length1;
#line 152 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		for (bookmark_it = 0; bookmark_it < _tmp5__length1; bookmark_it = bookmark_it + 1) {
#line 763 "bookmarks.c"
			gchar* _tmp6_;
			gchar* bookmark = NULL;
#line 152 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
			_tmp6_ = g_strdup (bookmark_collection[bookmark_it]);
#line 152 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
			bookmark = _tmp6_;
#line 770 "bookmarks.c"
			{
				const gchar* _tmp7_;
				gchar** _tmp8_;
				gint _tmp8__length1;
				gchar** _tmp9_;
				gint _tmp9__length1;
				const gchar* _tmp10_;
				gchar* _tmp11_;
				Bookmark* bookmark_row = NULL;
				const gchar* _tmp12_;
				Bookmark* _tmp13_;
				const gchar* _tmp14_;
				Bookmark* _tmp35_;
				GtkListBox* _tmp36_;
				Bookmark* _tmp37_;
#line 154 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				_tmp7_ = bookmark;
#line 154 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				_tmp8_ = unduplicated_bookmarks;
#line 154 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				_tmp8__length1 = unduplicated_bookmarks_length1;
#line 154 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				if (_vala_string_array_contains (_tmp8_, _tmp8__length1, _tmp7_)) {
#line 155 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_g_free0 (bookmark);
#line 155 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					continue;
#line 798 "bookmarks.c"
				}
#line 156 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				_tmp9_ = unduplicated_bookmarks;
#line 156 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				_tmp9__length1 = unduplicated_bookmarks_length1;
#line 156 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				_tmp10_ = bookmark;
#line 156 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				_tmp11_ = g_strdup (_tmp10_);
#line 156 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				_vala_array_add1 (&unduplicated_bookmarks, &unduplicated_bookmarks_length1, &_unduplicated_bookmarks_size_, _tmp11_);
#line 158 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				_tmp12_ = bookmark;
#line 158 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				_tmp13_ = bookmark_new (_tmp12_);
#line 158 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				g_object_ref_sink (_tmp13_);
#line 158 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				bookmark_row = _tmp13_;
#line 159 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				_tmp14_ = bookmark;
#line 159 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				if (settings_model_is_key_path (_tmp14_)) {
#line 822 "bookmarks.c"
					GVariant* variant = NULL;
					const gchar* _tmp15_;
					GVariant* _tmp16_;
					Bookmark* _tmp17_;
					GVariant* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					gchar* _tmp24_;
#line 161 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp15_ = bookmark;
#line 161 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp16_ = g_variant_new ("(ss)", _tmp15_, "", NULL);
#line 161 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					g_variant_ref_sink (_tmp16_);
#line 161 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					variant = _tmp16_;
#line 162 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp17_ = bookmark_row;
#line 162 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp18_ = variant;
#line 162 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp19_ = g_variant_print (_tmp18_, FALSE);
#line 162 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp20_ = _tmp19_;
#line 162 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp21_ = g_strconcat ("ui.open-object(", _tmp20_, NULL);
#line 162 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp22_ = _tmp21_;
#line 162 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp23_ = g_strconcat (_tmp22_, ")", NULL);
#line 162 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp24_ = _tmp23_;
#line 162 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp17_, _tmp24_);
#line 162 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_g_free0 (_tmp24_);
#line 162 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_g_free0 (_tmp22_);
#line 162 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_g_free0 (_tmp20_);
#line 159 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_g_variant_unref0 (variant);
#line 868 "bookmarks.c"
				} else {
					GVariant* variant = NULL;
					const gchar* _tmp25_;
					GVariant* _tmp26_;
					Bookmark* _tmp27_;
					GVariant* _tmp28_;
					gchar* _tmp29_;
					gchar* _tmp30_;
					gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					gchar* _tmp34_;
#line 166 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp25_ = bookmark;
#line 166 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp26_ = g_variant_new_string (_tmp25_);
#line 166 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					g_variant_ref_sink (_tmp26_);
#line 166 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					variant = _tmp26_;
#line 167 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp27_ = bookmark_row;
#line 167 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp28_ = variant;
#line 167 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp29_ = g_variant_print (_tmp28_, FALSE);
#line 167 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp30_ = _tmp29_;
#line 167 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp31_ = g_strconcat ("ui.open-folder(", _tmp30_, NULL);
#line 167 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp32_ = _tmp31_;
#line 167 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp33_ = g_strconcat (_tmp32_, ")", NULL);
#line 167 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp34_ = _tmp33_;
#line 167 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp27_, _tmp34_);
#line 167 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_g_free0 (_tmp34_);
#line 167 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_g_free0 (_tmp32_);
#line 167 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_g_free0 (_tmp30_);
#line 159 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_g_variant_unref0 (variant);
#line 915 "bookmarks.c"
				}
#line 169 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				_tmp35_ = bookmark_row;
#line 169 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				gtk_widget_show ((GtkWidget*) _tmp35_);
#line 170 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				_tmp36_ = self->priv->bookmarks_list_box;
#line 170 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				_tmp37_ = bookmark_row;
#line 170 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp37_);
#line 152 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				_g_object_unref0 (bookmark_row);
#line 152 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				_g_free0 (bookmark);
#line 931 "bookmarks.c"
			}
		}
	}
#line 172 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp38_ = self->priv->bookmarks_list_box;
#line 172 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp39_ = gtk_list_box_get_row_at_index (_tmp38_, 0);
#line 172 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp40_ = _g_object_ref0 (_tmp39_);
#line 172 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	first_row = _tmp40_;
#line 173 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp41_ = first_row;
#line 173 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	if (_tmp41_ != NULL) {
#line 947 "bookmarks.c"
		GtkListBox* _tmp42_;
		GtkListBoxRow* _tmp43_;
#line 174 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp42_ = self->priv->bookmarks_list_box;
#line 174 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp43_ = first_row;
#line 174 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		gtk_list_box_select_row (_tmp42_, G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, gtk_list_box_row_get_type (), GtkListBoxRow));
#line 956 "bookmarks.c"
	}
#line 146 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_g_object_unref0 (first_row);
#line 146 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	unduplicated_bookmarks = (_vala_array_free (unduplicated_bookmarks, unduplicated_bookmarks_length1, (GDestroyNotify) g_free), NULL);
#line 146 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	bookmarks = (_vala_array_free (bookmarks, bookmarks_length1, (GDestroyNotify) g_free), NULL);
#line 964 "bookmarks.c"
}


static void
_vala_array_add2 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 184 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	if ((*length) == (*size)) {
#line 184 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 184 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 980 "bookmarks.c"
	}
#line 184 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	(*array)[(*length)++] = value;
#line 184 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	(*array)[*length] = NULL;
#line 986 "bookmarks.c"
}


static void
bookmarks_append_bookmark (Bookmarks* self,
                           const gchar* path)
{
	GtkPopover* _tmp0_;
	gchar** bookmarks = NULL;
	GSettings* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint bookmarks_length1;
	gint _bookmarks_size_;
	gchar** _tmp4_;
	gint _tmp4__length1;
#line 177 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_return_if_fail (self != NULL);
#line 177 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_return_if_fail (path != NULL);
#line 179 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp0_ = self->priv->bookmarks_popover;
#line 179 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_signal_emit_by_name (_tmp0_, "closed");
#line 181 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp1_ = self->priv->settings;
#line 181 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "bookmarks");
#line 181 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	bookmarks = _tmp3_;
#line 181 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	bookmarks_length1 = _vala_array_length (_tmp2_);
#line 181 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_bookmarks_size_ = bookmarks_length1;
#line 182 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp4_ = bookmarks;
#line 182 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp4__length1 = bookmarks_length1;
#line 182 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	if (!_vala_string_array_contains (_tmp4_, _tmp4__length1, path)) {
#line 1027 "bookmarks.c"
		gchar** _tmp5_;
		gint _tmp5__length1;
		gchar* _tmp6_;
		GSettings* _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
#line 184 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp5_ = bookmarks;
#line 184 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp5__length1 = bookmarks_length1;
#line 184 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp6_ = g_strdup (path);
#line 184 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_vala_array_add2 (&bookmarks, &bookmarks_length1, &_bookmarks_size_, _tmp6_);
#line 185 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp7_ = self->priv->settings;
#line 185 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp8_ = bookmarks;
#line 185 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp8__length1 = bookmarks_length1;
#line 185 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		g_settings_set_strv (_tmp7_, "bookmarks", _tmp8_);
#line 1050 "bookmarks.c"
	}
#line 177 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	bookmarks = (_vala_array_free (bookmarks, bookmarks_length1, (GDestroyNotify) g_free), NULL);
#line 1054 "bookmarks.c"
}


static void
_vala_array_add3 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 199 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	if ((*length) == (*size)) {
#line 199 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 199 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1070 "bookmarks.c"
	}
#line 199 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	(*array)[(*length)++] = value;
#line 199 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	(*array)[*length] = NULL;
#line 1076 "bookmarks.c"
}


static void
bookmarks_remove_bookmark (Bookmarks* self,
                           const gchar* bookmark_name)
{
	GtkPopover* _tmp0_;
	gchar** old_bookmarks = NULL;
	GSettings* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint old_bookmarks_length1;
	gint _old_bookmarks_size_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** new_bookmarks = NULL;
	gchar** _tmp5_;
	gint new_bookmarks_length1;
	gint _new_bookmarks_size_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	GSettings* _tmp15_;
	gchar** _tmp16_;
	gint _tmp16__length1;
#line 189 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_return_if_fail (self != NULL);
#line 189 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_return_if_fail (bookmark_name != NULL);
#line 191 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp0_ = self->priv->bookmarks_popover;
#line 191 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_signal_emit_by_name (_tmp0_, "closed");
#line 193 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp1_ = self->priv->settings;
#line 193 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "bookmarks");
#line 193 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	old_bookmarks = _tmp3_;
#line 193 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	old_bookmarks_length1 = _vala_array_length (_tmp2_);
#line 193 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_old_bookmarks_size_ = old_bookmarks_length1;
#line 194 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp4_ = old_bookmarks;
#line 194 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp4__length1 = old_bookmarks_length1;
#line 194 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	if (!_vala_string_array_contains (_tmp4_, _tmp4__length1, bookmark_name)) {
#line 195 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		old_bookmarks = (_vala_array_free (old_bookmarks, old_bookmarks_length1, (GDestroyNotify) g_free), NULL);
#line 195 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		return;
#line 1130 "bookmarks.c"
	}
#line 196 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp5_ = g_new0 (gchar*, 0 + 1);
#line 196 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	new_bookmarks = _tmp5_;
#line 196 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	new_bookmarks_length1 = 0;
#line 196 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_new_bookmarks_size_ = new_bookmarks_length1;
#line 197 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp6_ = old_bookmarks;
#line 197 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp6__length1 = old_bookmarks_length1;
#line 1144 "bookmarks.c"
	{
		gchar** bookmark_collection = NULL;
		gint bookmark_collection_length1 = 0;
		gint _bookmark_collection_size_ = 0;
		gint bookmark_it = 0;
#line 197 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		bookmark_collection = _tmp6_;
#line 197 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		bookmark_collection_length1 = _tmp6__length1;
#line 197 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		for (bookmark_it = 0; bookmark_it < _tmp6__length1; bookmark_it = bookmark_it + 1) {
#line 1156 "bookmarks.c"
			gchar* _tmp7_;
			gchar* bookmark = NULL;
#line 197 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
			_tmp7_ = g_strdup (bookmark_collection[bookmark_it]);
#line 197 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
			bookmark = _tmp7_;
#line 1163 "bookmarks.c"
			{
				gboolean _tmp8_ = FALSE;
				const gchar* _tmp9_;
#line 198 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				_tmp9_ = bookmark;
#line 198 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				if (g_strcmp0 (_tmp9_, bookmark_name) != 0) {
#line 1171 "bookmarks.c"
					const gchar* _tmp10_;
					gchar** _tmp11_;
					gint _tmp11__length1;
#line 198 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp10_ = bookmark;
#line 198 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp11_ = new_bookmarks;
#line 198 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp11__length1 = new_bookmarks_length1;
#line 198 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp8_ = !_vala_string_array_contains (_tmp11_, _tmp11__length1, _tmp10_);
#line 1183 "bookmarks.c"
				} else {
#line 198 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp8_ = FALSE;
#line 1187 "bookmarks.c"
				}
#line 198 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				if (_tmp8_) {
#line 1191 "bookmarks.c"
					gchar** _tmp12_;
					gint _tmp12__length1;
					const gchar* _tmp13_;
					gchar* _tmp14_;
#line 199 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp12_ = new_bookmarks;
#line 199 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp12__length1 = new_bookmarks_length1;
#line 199 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp13_ = bookmark;
#line 199 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_tmp14_ = g_strdup (_tmp13_);
#line 199 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
					_vala_array_add3 (&new_bookmarks, &new_bookmarks_length1, &_new_bookmarks_size_, _tmp14_);
#line 1206 "bookmarks.c"
				}
#line 197 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
				_g_free0 (bookmark);
#line 1210 "bookmarks.c"
			}
		}
	}
#line 200 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp15_ = self->priv->settings;
#line 200 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp16_ = new_bookmarks;
#line 200 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp16__length1 = new_bookmarks_length1;
#line 200 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_settings_set_strv (_tmp15_, "bookmarks", _tmp16_);
#line 189 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	new_bookmarks = (_vala_array_free (new_bookmarks, new_bookmarks_length1, (GDestroyNotify) g_free), NULL);
#line 189 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	old_bookmarks = (_vala_array_free (old_bookmarks, old_bookmarks_length1, (GDestroyNotify) g_free), NULL);
#line 1226 "bookmarks.c"
}


Bookmarks*
bookmarks_construct (GType object_type)
{
	Bookmarks * self = NULL;
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	self = (Bookmarks*) g_object_new (object_type, NULL);
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	return self;
#line 1238 "bookmarks.c"
}


Bookmarks*
bookmarks_new (void)
{
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	return bookmarks_construct (TYPE_BOOKMARKS);
#line 1247 "bookmarks.c"
}


static const gchar*
bookmarks_get_schema_path (Bookmarks* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp0_ = self->priv->_schema_path;
#line 32 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	result = _tmp0_;
#line 32 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	return result;
#line 1264 "bookmarks.c"
}


static void
bookmarks_set_schema_path (Bookmarks* self,
                           const gchar* value)
{
#line 32 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_return_if_fail (self != NULL);
#line 32 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	if (g_strcmp0 (value, bookmarks_get_schema_path (self)) != 0) {
#line 1276 "bookmarks.c"
		gchar* _tmp0_;
#line 32 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_tmp0_ = g_strdup (value);
#line 32 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_g_free0 (self->priv->_schema_path);
#line 32 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		self->priv->_schema_path = _tmp0_;
#line 32 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		g_object_notify_by_pspec ((GObject *) self, bookmarks_properties[BOOKMARKS_SCHEMA_PATH_PROPERTY]);
#line 1286 "bookmarks.c"
	}
}


static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 35 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 35 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	return _data1_;
#line 1298 "bookmarks.c"
}


static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 35 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1309 "bookmarks.c"
		Bookmarks* self;
#line 35 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		self = _data1_->self;
#line 35 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		_g_object_unref0 (self);
#line 35 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		g_slice_free (Block1Data, _data1_);
#line 1317 "bookmarks.c"
	}
}


static void
_bookmarks___lambda96_ (Bookmarks* self)
{
#line 42 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	bookmarks_update_bookmarks (self);
#line 43 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	bookmarks_update_icon_and_switch (self);
#line 1329 "bookmarks.c"
}


static void
__bookmarks___lambda96__g_settings_changed (GSettings* _sender,
                                            const gchar* key,
                                            gpointer self)
{
#line 41 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_bookmarks___lambda96_ ((Bookmarks*) self);
#line 1340 "bookmarks.c"
}


static void
_bookmarks___lambda97_ (Bookmarks* self)
{
	GtkSwitch* _tmp0_;
#line 47 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp0_ = self->priv->bookmarked_switch;
#line 47 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp0_);
#line 1352 "bookmarks.c"
}


static void
__bookmarks___lambda97__gtk_button_clicked (GtkButton* _sender,
                                            gpointer self)
{
#line 47 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_bookmarks___lambda97_ ((Bookmarks*) self);
#line 1362 "bookmarks.c"
}


static void
_bookmarks___lambda98_ (Block1Data* _data1_)
{
	Bookmarks* self;
	GSettings* _tmp0_;
	gulong _tmp1_;
	gulong _tmp2_;
#line 49 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	self = _data1_->self;
#line 50 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp0_ = self->priv->settings;
#line 50 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp1_ = _data1_->bookmarks_changed_handler;
#line 50 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_signal_handler_disconnect ((GObject*) _tmp0_, _tmp1_);
#line 51 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp2_ = _data1_->clicked_handler;
#line 51 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_signal_handler_disconnect ((GObject*) self, _tmp2_);
#line 1385 "bookmarks.c"
}


static void
__bookmarks___lambda98__gtk_widget_destroy (GtkWidget* _sender,
                                            gpointer self)
{
#line 49 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_bookmarks___lambda98_ (self);
#line 1395 "bookmarks.c"
}


static GObject *
bookmarks_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Bookmarks * self;
	Block1Data* _data1_;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	gulong _tmp4_;
	gulong _tmp5_;
#line 35 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	parent_class = G_OBJECT_CLASS (bookmarks_parent_class);
#line 35 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 35 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOOKMARKS, Bookmarks);
#line 35 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 35 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_data1_->_ref_count_ = 1;
#line 35 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_data1_->self = g_object_ref (self);
#line 37 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	bookmarks_install_action_entries (self);
#line 39 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp0_ = self->priv->schema_id;
#line 39 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp1_ = self->priv->_schema_path;
#line 39 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp2_ = g_settings_new_with_path (_tmp0_, _tmp1_);
#line 39 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_g_object_unref0 (self->priv->settings);
#line 39 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	self->priv->settings = _tmp2_;
#line 41 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp3_ = self->priv->settings;
#line 41 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp4_ = g_signal_connect_object (_tmp3_, "changed::bookmarks", (GCallback) __bookmarks___lambda96__g_settings_changed, self, 0);
#line 41 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_data1_->bookmarks_changed_handler = _tmp4_;
#line 46 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	bookmarks_update_bookmarks (self);
#line 47 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp5_ = g_signal_connect_object ((GtkButton*) self, "clicked", (GCallback) __bookmarks___lambda97__gtk_button_clicked, self, 0);
#line 47 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_data1_->clicked_handler = _tmp5_;
#line 49 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_signal_connect_data ((GtkWidget*) self, "destroy", (GCallback) __bookmarks___lambda98__gtk_widget_destroy, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 35 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	block1_data_unref (_data1_);
#line 35 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_data1_ = NULL;
#line 35 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	return obj;
#line 1458 "bookmarks.c"
}


static void
bookmarks_class_init (BookmarksClass * klass)
{
	gint Bookmarks_private_offset;
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	bookmarks_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_type_class_add_private (klass, sizeof (BookmarksPrivate));
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_bookmarks_get_property;
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_bookmarks_set_property;
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	G_OBJECT_CLASS (klass)->constructor = bookmarks_constructor;
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	G_OBJECT_CLASS (klass)->finalize = bookmarks_finalize;
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOOKMARKS_SCHEMA_PATH_PROPERTY, bookmarks_properties[BOOKMARKS_SCHEMA_PATH_PROPERTY] = g_param_spec_string ("schema-path", "schema-path", "schema-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	Bookmarks_private_offset = g_type_class_get_instance_private_offset (klass);
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/ca/desrt/dconf-editor/ui/bookmarks.ui");
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "bookmarks_list_box", FALSE, Bookmarks_private_offset + G_STRUCT_OFFSET (BookmarksPrivate, bookmarks_list_box));
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "bookmarks_popover", FALSE, Bookmarks_private_offset + G_STRUCT_OFFSET (BookmarksPrivate, bookmarks_popover));
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "bookmarks_icon", FALSE, Bookmarks_private_offset + G_STRUCT_OFFSET (BookmarksPrivate, bookmarks_icon));
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "bookmarked_switch", FALSE, Bookmarks_private_offset + G_STRUCT_OFFSET (BookmarksPrivate, bookmarked_switch));
#line 1492 "bookmarks.c"
}


static void
bookmarks_instance_init (Bookmarks * self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	self->priv = BOOKMARKS_GET_PRIVATE (self);
#line 29 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp0_ = g_strdup ("/");
#line 29 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	self->priv->current_path = _tmp0_;
#line 31 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp1_ = g_strdup ("ca.desrt.dconf-editor.Bookmarks");
#line 31 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	self->priv->schema_id = _tmp1_;
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1513 "bookmarks.c"
}


static void
bookmarks_finalize (GObject * obj)
{
	Bookmarks * self;
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOOKMARKS, Bookmarks);
#line 23 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_g_object_unref0 (self->priv->bookmarks_list_box);
#line 24 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_g_object_unref0 (self->priv->bookmarks_popover);
#line 26 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_g_object_unref0 (self->priv->bookmarks_icon);
#line 27 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_g_object_unref0 (self->priv->bookmarked_switch);
#line 29 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_g_free0 (self->priv->current_path);
#line 31 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_g_free0 (self->priv->schema_id);
#line 32 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_g_free0 (self->priv->_schema_path);
#line 33 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_g_object_unref0 (self->priv->settings);
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	G_OBJECT_CLASS (bookmarks_parent_class)->finalize (obj);
#line 1541 "bookmarks.c"
}


GType
bookmarks_get_type (void)
{
	static volatile gsize bookmarks_type_id__volatile = 0;
	if (g_once_init_enter (&bookmarks_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BookmarksClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bookmarks_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Bookmarks), 0, (GInstanceInitFunc) bookmarks_instance_init, NULL };
		GType bookmarks_type_id;
		bookmarks_type_id = g_type_register_static (gtk_menu_button_get_type (), "Bookmarks", &g_define_type_info, 0);
		g_once_init_leave (&bookmarks_type_id__volatile, bookmarks_type_id);
	}
	return bookmarks_type_id__volatile;
}


static void
_vala_bookmarks_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	Bookmarks * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BOOKMARKS, Bookmarks);
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		case BOOKMARKS_SCHEMA_PATH_PROPERTY:
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		g_value_set_string (value, bookmarks_get_schema_path (self));
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		break;
#line 1575 "bookmarks.c"
		default:
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		break;
#line 1581 "bookmarks.c"
	}
}


static void
_vala_bookmarks_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	Bookmarks * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BOOKMARKS, Bookmarks);
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		case BOOKMARKS_SCHEMA_PATH_PROPERTY:
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		bookmarks_set_schema_path (self, g_value_get_string (value));
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		break;
#line 1602 "bookmarks.c"
		default:
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
		break;
#line 1608 "bookmarks.c"
	}
}


Bookmark*
bookmark_construct (GType object_type,
                    const gchar* bookmark_name)
{
	Bookmark * self = NULL;
	GtkLabel* _tmp0_;
	GVariant* variant = NULL;
	GVariant* _tmp1_;
	GtkButton* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 210 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_return_val_if_fail (bookmark_name != NULL, NULL);
#line 210 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	self = (Bookmark*) g_object_new (object_type, NULL);
#line 212 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp0_ = self->priv->bookmark_label;
#line 212 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	gtk_label_set_label (_tmp0_, bookmark_name);
#line 213 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp1_ = g_variant_new_string (bookmark_name);
#line 213 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_variant_ref_sink (_tmp1_);
#line 213 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	variant = _tmp1_;
#line 214 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp2_ = self->priv->destroy_button;
#line 214 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp3_ = g_variant_print (variant, FALSE);
#line 214 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp4_ = _tmp3_;
#line 214 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp5_ = g_strconcat ("bookmarks.unbookmark(", _tmp4_, NULL);
#line 214 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp6_ = _tmp5_;
#line 214 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp7_ = g_strconcat (_tmp6_, ")", NULL);
#line 214 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_tmp8_ = _tmp7_;
#line 214 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp2_, _tmp8_);
#line 214 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_g_free0 (_tmp8_);
#line 214 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_g_free0 (_tmp6_);
#line 214 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_g_free0 (_tmp4_);
#line 210 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_g_variant_unref0 (variant);
#line 210 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	return self;
#line 1668 "bookmarks.c"
}


Bookmark*
bookmark_new (const gchar* bookmark_name)
{
#line 210 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	return bookmark_construct (TYPE_BOOKMARK, bookmark_name);
#line 1677 "bookmarks.c"
}


static void
bookmark_class_init (BookmarkClass * klass)
{
	gint Bookmark_private_offset;
#line 205 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	bookmark_parent_class = g_type_class_peek_parent (klass);
#line 205 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	g_type_class_add_private (klass, sizeof (BookmarkPrivate));
#line 205 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	G_OBJECT_CLASS (klass)->finalize = bookmark_finalize;
#line 205 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	Bookmark_private_offset = g_type_class_get_instance_private_offset (klass);
#line 205 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/ca/desrt/dconf-editor/ui/bookmark.ui");
#line 205 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "bookmark_label", FALSE, Bookmark_private_offset + G_STRUCT_OFFSET (BookmarkPrivate, bookmark_label));
#line 205 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "destroy_button", FALSE, Bookmark_private_offset + G_STRUCT_OFFSET (BookmarkPrivate, destroy_button));
#line 1699 "bookmarks.c"
}


static void
bookmark_instance_init (Bookmark * self)
{
#line 205 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	self->priv = BOOKMARK_GET_PRIVATE (self);
#line 205 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1710 "bookmarks.c"
}


static void
bookmark_finalize (GObject * obj)
{
	Bookmark * self;
#line 205 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOOKMARK, Bookmark);
#line 207 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_g_object_unref0 (self->priv->bookmark_label);
#line 208 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	_g_object_unref0 (self->priv->destroy_button);
#line 205 "/builddir/build/BUILD/dconf-editor-3.28.0/editor/bookmarks.vala"
	G_OBJECT_CLASS (bookmark_parent_class)->finalize (obj);
#line 1726 "bookmarks.c"
}


GType
bookmark_get_type (void)
{
	static volatile gsize bookmark_type_id__volatile = 0;
	if (g_once_init_enter (&bookmark_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BookmarkClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bookmark_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Bookmark), 0, (GInstanceInitFunc) bookmark_instance_init, NULL };
		GType bookmark_type_id;
		bookmark_type_id = g_type_register_static (gtk_list_box_row_get_type (), "Bookmark", &g_define_type_info, 0);
		g_once_init_leave (&bookmark_type_id__volatile, bookmark_type_id);
	}
	return bookmark_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



